#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define MAXCAMS 4
#define RAW_VIDEO 1
#define DAV_VIDEO 2

#ifndef SSIZE_MAX
#define SSIZE_MAX 1460
#endif

void conexiones();
void conectarcam(int cam);
void desconectarcam(int cam);
void *primeraConexion();
void *segundaConexion();
void *videoConexion(void *arg);

struct sockaddr_in dir;
int  sock1, sock2;
int  sockcam[MAXCAMS];
int  conscam[MAXCAMS];
char id1, id2, channel, cams[MAXCAMS];
int  flag = 0, flagfv;

int  videos[MAXCAMS];
int  videosnet[MAXCAMS];

void main (void){
	pthread_t tid1, tid2, tid3, tidcam[MAXCAMS]; 
	int i;

	for(i=0;i<MAXCAMS;i++)
	{
		conscam[i]=0;
	}

	channel = (char) 0x01;
	cams[1]=cams[2]=cams[3]=(char) 0x00;
	cams[0]=(char) 0x01;
	
	printf("\nDVR Leeching Tool\n");
	printf("Selecciona el formato de los archivos de video (defecto: Raw):\n");
	printf("1- Raw (video h.264)\n");
	printf("2- Dav (propietario dvr)\n");
	scanf("%d",&flagfv);
	switch(flagfv)
	{
		case 1: break;
		case 2: break;
		default: flagfv = 1;
			break;
	}

	printf("\nSelecciona camara (1-4):\n");
	scanf("%d",&flag);
	switch(flag)
	{
		case 1: break;
		case 2: channel = (char) 0x02;
			cams[0]=cams[2]=cams[3]=(char) 0x00;
			cams[1]=(char) 0x01;
			break;
		case 3: channel = (char) 0x03;
			cams[1]=cams[0]=cams[3]=(char) 0x00;
			cams[2]=(char) 0x01;
			break;
		case 4: channel = (char) 0x04;
			cams[1]=cams[2]=cams[0]=(char) 0x00;
			cams[3]=(char) 0x01;
			break;
		default: printf("Camaras disponibles 1-4. Seleccionada la camara 1 por defecto.\n");
			 break;
	}

	flag = 1;

	conscam[(int)channel-1]=1;

	conexiones(); // establecemos las conexiones con la informacion que tenemos hasta aqui

	pthread_create(&tid1, NULL, primeraConexion, NULL);
	pthread_create(&tid2, NULL, segundaConexion, NULL);
	pthread_create(&tidcam[(int)channel-1], NULL, videoConexion, (void*)(int)channel-1);

	while (flag)
	{
		printf("********************************************************************\n");
		printf("Flag es %d\n", flag);
		printf("Camaras activas son:\t"); // no mostrara las recien desconectadas
		for (i=0; i<MAXCAMS; i++) if (conscam[i]) printf("%d ", i+1);
		printf("\nIntroduce comando (0 para salir):\n");
		printf("Activar camara 1-4:\t  1  2  3  4\n");
		printf("Desactivar camara 1-4:\t 11 12 13 14\n");
		printf("********************************************************************\n");
		scanf("%d",&flag);
		if (flag)
		{
			if (flag>0 && flag<5)
			{
				if (conscam[flag-1]) printf("Camara %d ya ocupada.\n", flag);
				else
				{
					conscam[flag-1]=1;
					pthread_create(&tidcam[flag-1], NULL, videoConexion, (void*)flag-1);
				}
			}
			else if (flag>10 && flag<15)
			{
				if (conscam[flag-11]) conscam[flag-11]=0;
				else
				{
					printf("Camara %d ya desocupada.\n", flag-10);
				}				
			}
			else printf("Comando nulo.\n");
		}
	}
	
	printf("Flag es %d\n", flag);

	pthread_join(tid2, NULL);
	pthread_join(tid1, NULL);

	close(sock2);

	char sendbuflast[]={ 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, id1, id2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	
	if (write(sock1, sendbuflast, 32)==-1) {
		printf("Error: writelast\n");
	}
	else {
		printf("writelast\n");
	}

	close(sock1);

	exit(0);
}
 
/*****************************************************************************************************************\
\*****************************************************************************************************************/

/*por Stream 0 los 01 indican canales abiertos
11 00 00 00 10 00 00 00  01 01 01 01 00 00 00 00
00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00
00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00
*/

void conectarcam(int cam)
{
	fd_set set;
	struct timeval timeout;

	FD_ZERO(&set);
	FD_SET(sock1, &set);
	timeout.tv_sec=1;
	timeout.tv_usec=0;

	cams[cam] = (char) 0x01;
//	conscam[cam]=1; //comento para actualizar bien la lista de cams activas en main()

	char sendbufconnect[]={ 0x11, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, cams[0], cams[1], cams[2], cams[3], 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	if(select(sock1+1,NULL,&set,NULL,&timeout)>=0)
	{
		if (write(sock1, sendbufconnect, 48)==-1) {
			printf("Error: writeconnectcam %d\n", cam+1);
		}
		else {
			printf("writeconnectcam %d\n", cam+1);
		}
	}
}
void desconectarcam(int cam)
{
	fd_set set;
	struct timeval timeout;

	FD_ZERO(&set);
	FD_SET(sock1, &set);
	timeout.tv_sec=1;
	timeout.tv_usec=0;

	cams[cam] = (char) 0x00;
//	conscam[cam]=0;

	char sendbufdisconnect[]={ 0x11, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, cams[0], cams[1], cams[2], cams[3], 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	if(select(sock1+1,NULL,&set,NULL,&timeout)>=0)
	{
		if (write(sock1, sendbufdisconnect, 48)==-1) {
			printf("Error: writedisconnectcam %d\n", cam+1);
		}
		else {
			printf("writedisconnectcam %d\n", cam+1);
		}
	}
}

/*****************************************************************************************************************\
\*****************************************************************************************************************/


//selects para que la lectura no se quede siempre bloqueada esperando paquetes que tal vez no lleguen
void* primeraConexion (){
	printf("primeraConexion\n");
	fd_set set;
	struct timeval timeout;

	FD_ZERO(&set);
	FD_SET(sock1, &set);
	timeout.tv_sec=1;
	timeout.tv_usec=0;
	
	while (flag) {
		char recvbufcon1[32] = "";
		
		if(select(sock1+1,&set,NULL,NULL,&timeout)>0)
		{
			if (read(sock1, recvbufcon1, 32)==-1) {
				printf("Error: readcon1\n");
			}
			else {
				printf("readcon1\n");
			}
		}
	}

	printf("salgo hilo 1\n");
	pthread_exit(NULL); 
}

void* segundaConexion (){
	printf("segundaConexion\n");
	fd_set set;
	struct timeval timeout;

	FD_ZERO(&set);
	FD_SET(sock2, &set);
	timeout.tv_sec=1;
	timeout.tv_usec=0;

	int bytes = 0;
	
	while (flag) {
		char recvbufcon2[32] = "";
		
		if(select(sock2+1,&set,NULL,NULL,&timeout)>0)
		{
			bytes = read(sock2, recvbufcon2, 32);
		
			if (bytes==-1) {
				printf("Error: readcon2\n");
			}
			else {
				printf("readcon2: bytes: %i\n", bytes);
			}
			//Paquete dummy para enviar por si se recibe algo por este canal.
			char sendbuf6[]={ 0xa1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
			write(sock1, sendbuf6, 32);
		}
	}
	printf("salgo hilo 2\n");
	pthread_exit(NULL); 
}

void* videoConexion (void* arg){
	int id = (int)arg;
	int i,j,k;

	printf("videoConexion %d\n", id+1);

	//Stream Video

	sockcam[id] = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	
	if (connect(sockcam[id], (struct sockaddr *) &dir, sizeof(struct sockaddr_in))<0) {
		printf("Error: connectvideo %d\n", id+1);
	}
	else {
		printf("connectvideo %d\n", id+1);
	}
	//1
	char sendbufvideoconexion[]={ 0xf1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, id1, id2, 0x00, 0x00, 0x01, (char)id+1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	char recvbufvideoconexion[32] = "";
	
	if (write(sockcam[id], sendbufvideoconexion, 32)==-1) {
		printf("Error: writevideoconexion\n");
	}
	else {
		printf("writevideoconexion\n");
	}
	
	if (read(sockcam[id], recvbufvideoconexion, 32)==-1) {
		printf("Error: readvideoconexion\n");
	}
	else {
		printf("readvideoconexion\n");
	}

	//Control canales
	conectarcam(id);

	//preparamos archivo para volcar stream de video
	char nombre[]="camX.raw";
	nombre[3] = id+49;
	
	char nombrenet[]="camX.net";
	nombrenet[3] = id+49;
	
	
	if (flagfv == DAV_VIDEO)
	{
		nombre[5] = 'd';
		nombre[6] = 'a';
		nombre[7] = 'v';
	}

	videos[id] = open(nombre, O_WRONLY | O_CREAT, 0644);//O_APPEND para añadir al final del archivo
	videosnet[id] = open(nombrenet, O_WRONLY | O_CREAT, 0644);//O_APPEND para añadir al final del archivo
	
	int  num   = 0;
	int  bytes = 0;

	char senyal[] = {0xbc, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	char cab_dhav[] = {(int)'D', (int)'H', (int)'A', (int)'V', 0xf0, 0x00, 0x00, 0x00, 0xee, 0xee, 0xcc, 0x00, 0xff, 0xff, 0x00, 0x00};

	char col_dhav[] = {(int)'d', (int)'h', (int)'a', (int)'v', 0xff, 0xff, 0x00, 0x00};

	char del1, del2;//, cam;
	
	while (flag && (flag != id+11) ) //id+11 es el comando para terminar la camara id+1 (ej. id=0 +1 -> camara 1)	
	{
		char recvbufvideo[SSIZE_MAX] = "";
		int  cabecera = 1;

		bytes = read(sockcam[id], recvbufvideo, SSIZE_MAX);

		write(videosnet[id], recvbufvideo, bytes);

		for (i=0; i<bytes; i++)
		{
			//Eliminamos Cabecera de Red (32)
			if(recvbufvideo[i] == senyal[0])
			{
				for (j=1; j<32; j++)
				{
					if ( (j != 4) && (j != 5) && (j != 8) )
					{
						if (recvbufvideo[i+j] != senyal[j]) 
						{
							cabecera = 0;
//							printf("NOOOOOO CABECERA\n");
							break;
						}
					}// j==4 -> del1 ; j==5 -> del2 ; j==8 -> cam .
				}
				if (cabecera)
				{
//					printf("CABECERA\n");
					bytes -= 32;

					for (j=i; j<bytes; j++)
					{
						recvbufvideo[j] = recvbufvideo[j+32];
					}
				}
				else cabecera = 1;				
			}
			
			//Quitar los dhav_F0 para tener .dav limpio
			if( (recvbufvideo[i] == cab_dhav[0]) && (recvbufvideo[i+1] == cab_dhav[1]) &&
			(recvbufvideo[i+2] == cab_dhav[2]) && (recvbufvideo[i+3] == cab_dhav[3]) && 
			(recvbufvideo[i+4] == cab_dhav[4]) )
			{
				//printf("Cabecera dhav NULA (F0)\n");
				del1 = recvbufvideo[i+12];
				del2 = recvbufvideo[i+13];
				
				for (k=32; k<=bytes-8; k++)
				{
					if( (recvbufvideo[i+k] == col_dhav[0]) && (recvbufvideo[i+1+k] == col_dhav[1]) &&
					(recvbufvideo[i+2+k] == col_dhav[2]) && (recvbufvideo[i+3+k] == col_dhav[3]) && 
					(recvbufvideo[i+4+k] == del1) && (recvbufvideo[i+5+k] == del2) )
					{
						break;
					}
				}
				
				k += 8;				
				bytes -= k;

				for (j=i; j<bytes; j++)
				{
					recvbufvideo[j] = recvbufvideo[j+k];
				}
			}

			if (flagfv == RAW_VIDEO)
			{
				//Eliminamos Cabecera Propietaria DHAV (32)
				if( (recvbufvideo[i] == cab_dhav[0]) && (recvbufvideo[i+1] == cab_dhav[1]) &&
				(recvbufvideo[i+2] == cab_dhav[2]) && (recvbufvideo[i+3] == cab_dhav[3]) )
				{
					//printf("Cabecera DHAV\n");
					//cam  = recvbufvideo[i+10];
					del1 = recvbufvideo[i+12];
					del2 = recvbufvideo[i+13];
					bytes -= 32;

					for (j=i; j<bytes; j++)
					{
						recvbufvideo[j] = recvbufvideo[j+32];
					}
				}
				//Eliminamos Cola Propietaria dhav (8)
				if( (recvbufvideo[i] == col_dhav[0]) && (recvbufvideo[i+1] == col_dhav[1]) &&
				(recvbufvideo[i+2] == col_dhav[2]) && (recvbufvideo[i+3] == col_dhav[3]) )
				{
					//printf("Cola dhav\n");
					if ( (del1 == recvbufvideo[i+4]) && (del2 == recvbufvideo[i+5]) )
					{
						bytes -= 8;

						for (j=i; j<bytes; j++)
						{
							recvbufvideo[j] = recvbufvideo[j+8];
						}
					}
					else printf("ein??? cam%d\n", id+1);
				}
			}
		}
	
		if (bytes==-1) {
			printf("Error: readvideo %d\n", id+1);
		}
		else {
			write(videos[id], recvbufvideo, bytes);
		}
		num++;
	}
	printf("salgo hilo camara %d\n", id+1);
	desconectarcam(id);
	close(sockcam[id]);
	close(videos[id]);
	pthread_exit(NULL); 
}

/*****************************************************************************************************************\
\*****************************************************************************************************************/

void conexiones()
{
	
	dir.sin_family = PF_INET;
	dir.sin_port = htons(37777);
	
	if (inet_aton("147.156.223.240", &dir.sin_addr)==0) {
		printf("Error: inet_aton\n");
	}
	else {
		printf("inet_aton\n");
	}
	
	sock1 = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	
	if (connect(sock1, (struct sockaddr *) &dir, sizeof(struct sockaddr_in))<0) {
		printf("Error: connect\n");
	}
	else {
		printf("connect\n");
	}

	//Stream 0 - Primera Conexion
	//1a
	char sendbuf1[]={ 0xa0, 0x00, 0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x61, 0x64, 0x6d, 0x69, 0x6e, 0x00, 0x00, 0x00, 0x61, 0x64, 0x6d, 0x69, 0x6e,0x00, 0x00, 0x00, 0x04, 0x01, 0x00, 0x00, 0x00, 0x00, 0xa1, 0xaa};
	
	char recvbuf1[32] = "";
	
	if (write(sock1, sendbuf1, 32)==-1) {
		printf("Error: write1\n");
	}
	else {
		printf("write1\n");
	}
	
	if (read(sock1, recvbuf1, 32)==-1) {
		printf("Error: read1\n");
	}
	else {
		printf("read1\n");
		
		id1 = recvbuf1[16];
		id2 = recvbuf1[17];
	}
	
	//2a
	
	char sendbuf2[]={ 0xa1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	char recvbuf2[32] = "";
	
	if (write(sock1, sendbuf2, 32)==-1) {
		printf("Error: write2\n");
	}
	else {
		printf("write2\n");
	}
	
	if (read(sock1, recvbuf2, 32)==-1) {
		printf("Error: read2\n");
	}
	else {
		printf("read2\n");
	}
	
	//Stream 1 - Segunda Conexion
	
	/*dir.sin_family = PF_INET;
	dir.sin_port = htons(37777);
	
	if (inet_aton("147.156.223.240", &dir.sin_addr)==0) {
		printf("Error: inet_aton\n");
	}
	else {
		printf("inet_aton\n");
	}*/
	
	sock2 = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	
	if (connect(sock2, (struct sockaddr *) &dir, sizeof(struct sockaddr_in))<0) {
		printf("Error: connect2\n");
	}
	else {
		printf("connect2\n");
	}
	
	//1b
	
	char sendbuf7[]={ 0xf1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, id1, id2, 0x00, 0x00, 0x02, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	char recvbuf7[32] = "";
	
	if (write(sock2, sendbuf7, 32)==-1) {
		printf("Error: write7\n");
	}
	else {
		printf("write7\n");
	}
	
	if (read(sock2, recvbuf7, 32)==-1) {
		printf("Error: read7\n");
	}
	else {
		printf("read7\n");
	}
		
	//3a
	
	char sendbuf3[]={ 0xa4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	char recvbuf3[64] = "";
	
	if (write(sock1, sendbuf3, 32)==-1) {
		printf("Error: write3\n");
	}
	else {
		printf("write3\n");
	}
	
	if (read(sock1, recvbuf3, 64)==-1) {
		printf("Error: read3\n");
	}
	else {
		printf("read3\n");
	}
	
	//4a
	
	char sendbuf4[]={ 0xa4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	char recvbuf4[54] = "";
	
	if (write(sock1, sendbuf4, 32)==-1) {
		printf("Error: write4\n");
	}
	else {
		printf("write4\n");
	}
	
	if (read(sock1, recvbuf4, 54)==-1) {
		printf("Error: read4\n");
	}
	else {
		printf("read4\n");
	}
	
	//5a
	
	char sendbuf5[]={ 0xa4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	char recvbuf5[368] = "";
	
	if (write(sock1, sendbuf5, 32)==-1) {
		printf("Error: write5\n");
	}
	else {
		printf("write5\n");
	}
	
	if (read(sock1, recvbuf5, 368)==-1) {
		printf("Error: read5\n");
	}
	else {
		printf("read5\n");
	}
}
